import es, random, gamethread, playerlib ,os ,services, popuplib, usermsg

info = es.AddonInfo()
info.name = 'rsounds'
info.version = '1.3.0'
info.url = ''
info.basename = 'rsounds'
info.author = 'Ch@meleon'

################################################
# Installation:
################################################
# 1. Put sounds directly into your cstrike/sounds/rsounds folder on the server
# 2. Put plugin into eventscripts directory
# 3. Add es_load rsounds into autoexec.cfg
# PS: Remember! Sound files must be smaller than 150Kb! Or players hate your server :-] for download musics

sounds = { 'ONEVONE':    { 'ENABLE': 1, 'SOUNDS': ['rsounds/oneonone.mp3'] } \
         , 'ONEONLY':    { 'ENABLE': 1, 'SOUNDS': ['rsounds/oneandonly.mp3'] } \
         , 'FLAWLESS':   { 'ENABLE': 1, 'SOUNDS': ['rsounds/flawless.mp3'] } \
         , 'SUICIDE':    { 'ENABLE': 1, 'SOUNDS': ['bot/noo.wav'] } \
         , 'TEAMATTACK': { 'ENABLE': 1, 'SOUNDS': ['bot/stop_it.wav'] } \
         , 'KNIFEKILL':  { 'ENABLE': 1, 'SOUNDS': ['rsounds/hru1.mp3','rsounds/hru2.mp3','quake/kabanchek.mp3'] } \
         , 'LOSTLEAD':   { 'ENABLE': 1, 'SOUNDS': ['rsounds/lostforlead.mp3'] } \
         , 'TAKENLEAD':  { 'ENABLE': 1, 'SOUNDS': ['rsounds/takenforlead.mp3'] } \
         , 'HEGRENADE': { 'ENABLE': 1, 'SOUNDS': ['bot/noo.wav'] } \
         , 'HEGRENADE_THROW': { 'ENABLE': 1, 'SOUNDS': ['bot/noo.wav'] } \
#         , 'HEGRENADE_BOUNCE_DEF' : { 'ENABLE': 1, 'SOUNDS': ['weapons\hegrenade\he_bounce-1.wav'] } \
#         , 'TERWIN': { 'ENABLE': 1, 'SOUNDS': ['ambient/music/dustmusic1.wav','ambient/music/dustmusic2.wav','ambient/music/dustmusic3.wav'] } \
#         , 'CTWIN':  { 'ENABLE': 1, 'SOUNDS': ['ambient/music/piano1.wav','ambient/music/piano2.wav','ambient/music/latin.wav'] } \
         , 'TERWIN': { 'ENABLE': 1, 'SOUNDS': ['rsounds/t1.mp3','rsounds/t2.mp3','rsounds/t3.mp3','rsounds/t4.mp3','rsounds/t5.mp3','rsounds/t6.mp3','rsounds/t7.mp3','rsounds/t8.mp3'] } \
         , 'CTWIN': { 'ENABLE': 1, 'SOUNDS': ['rsounds/ct1.mp3','rsounds/ct2.mp3','rsounds/ct3.mp3','rsounds/ct4.mp3','rsounds/ct5.mp3','rsounds/ct6.mp3','rsounds/ct7.mp3','rsounds/ct8.mp3'] } \
         }

settings = { 'PLAYRANDOM': 1 \
           }
# To disable some sounds set Enable to 0

################################################
# Do not edit below this line
################################################

plrset = []
t_death = 0
ct_death = 0
ct_lead = 0
t_lead = 0
t_s = 1
ct_s = 1
mani_quake_hum = 0

def load():
	es.set(info.basename,info.version)
	es.makepublic(info.basename)
	downstr()
	loadsets()
	if not es.exists('saycommand', 'roundmusic'):
		es.regsaycmd('roundmusic', 'rsounds/change_music')
	if es.ServerVar('mani_quake_humiliation_mode')==1:
		mani_quake_hum = 1
		es.server.queuecmd('mani_quake_humiliation_mode %s'%'0')
	es.set('eventscripts_noisy', '1')

	#es.doblock("corelib/noisy_on")

	#sounds['ONEVONE']['LASTPLAYED']=0
	#print sounds['ONEVONE']['LASTPLAYED']

def unload():
    if es.exists('saycommand', 'sounds'):
        es.unregsaycmd('sounds')
	savesets()
	if mani_quake_num == 1:
		es.server.queuecmd('mani_quake_humiliation_mode %s'%'1')

def es_map_start(ev):
	global ct_lead, t_lead
	ct_lead = 0
	t_lead = 0
	downstr()
	savesets()

def game_end(ev):
	savesets()

def player_death(ev):
	global t_death, ct_death
	if es.getplayerteam(ev['userid']) == 2:
		t_death = t_death + 1
	if es.getplayerteam(ev['userid']) == 3:
		ct_death = ct_death + 1
	# Play when suicide
	if ev['userid']==ev['attacker']:
		play_snd(ev['userid'],get_snd('SUICIDE'),'1.0')
		#es.playsound(ev['userid'],getsound('SUICIDE'),'1.0')
	# Play when kill with knife
	if es.getplayerteam(ev['userid'])!=es.getplayerteam(ev['attacker']) and ev['weapon']=='knife':
		myPlayerList = playerlib.getPlayerList('#all')
		for ply in myPlayerList:
			userid = int(ply.userid)
			play_snd(userid,get_snd('KNIFEKILL'),'1.0')
			#es.playsound(userid,getsound('KNIFEKILL'),'1.0')
	# Play OneAndOnly to last T
	if es.getlivingplayercount(3) > 1 and es.getlivingplayercount(2) == 1 and es.getplayerteam(ev['userid']) == 2:
		myPlayerList = playerlib.getPlayerList('#t,#alive')
		for ply in myPlayerList:
			userid = int(ply.userid)
			play_snd(userid,get_snd('ONEONLY'),'1.0')
			#es.playsound(userid,getsound('ONEONLY'),'1.0')
	# Play OneAndOnly to last CT
	if  es.getlivingplayercount(2) > 1 and es.getlivingplayercount(3) == 1 and es.getplayerteam(ev['userid']) == 3:
		myPlayerList = playerlib.getPlayerList('#ct,#alive')
		for ply in myPlayerList:
			userid = int(ply.userid)
			play_snd(userid,get_snd('ONEONLY'),'1.0')
			#es.playsound(userid,getsound('ONEONLY'),'1.0')
	# Play OneOnOne to last players
	if es.getlivingplayercount(2) == 1 and es.getlivingplayercount(3) == 1:
		myPlayerList = playerlib.getPlayerList('#all')
		for ply in myPlayerList:
			userid = int(ply.userid)
			play_snd(userid,get_snd('ONEVONE'),'1.0')
			#es.playsound(userid,getsound('ONEVONE'),'1.0')
	getlead()


def change_music():
	global plrset
	userid = es.getcmduserid()
	plrUid = playerlib.uniqueid(userid)
	if plrUid in plrset:
		es.tell (userid, "#multi", "#green " + 'Change round-end music to ON')
		enbl = 1
		plrset.remove(plrUid)
	else:
		es.tell (userid, "#multi", "#green " + 'Change round-end music to OFF')
		enbl = 0
		plrset.append(plrUid)

def player_hurt(ev):
	if es.getplayerteam(ev['userid']) == es.getplayerteam(ev['attacker']):
		if es.isbot(ev['attacker'])==0 and ev['userid']!=ev['attacker']:
			play_snd(ev['attacker'],get_snd('TEAMATTACK'),'1.0')
			#es.playsound(ev['attacker'],getsound('TEAMATTACK'),'1.0')

def round_start(ev):
	global t_death, ct_death
	t_death = 0
	ct_death = 0
	if es.ServerVar('mani_quake_humiliation_mode') == 1:
		es.server.queuecmd('mani_quake_humiliation_mode %s'%'0')

def round_end(ev):
	# play EndRound music to all players
	global plrset, t_death, ct_death
	if int(es.event_var['winner']) == 2:
		snd = get_snd('TERWIN')
	elif int(es.event_var['winner']) == 3:
		snd = get_snd('CTWIN')
	else:
		snd = get_snd('TERWIN')
	# if flawless - then play flawless victory music
	if ( (t_death==0 and ct_death>3) or (ct_death==0 and t_death>3)):
		snd = get_snd('FLAWLESS')
	myPlayerList = playerlib.getPlayerList('#all')
	for ply in myPlayerList:
		plrUid = playerlib.uniqueid(int(ply.userid))
		if not plrUid in plrset:
			play_snd(int(ply.userid),snd,'0.8')
			#es.playsound(int(ply.userid),snd,'0.8')


#def hegrenade_detonate(ev):
#	print 'HEGREN'
#	myPlayerList = playerlib.getPlayerList('#all')
#	for ply in myPlayerList:
#		es.stopsound(int(ply.userid),'radio/ct_fireinhole.wav')
#		play_snd(int(ply.userid),get_snd('HEGRENADE'),'0.8')

#def grenade_bounce(ev):
#	print 'HEGREN_BOUNCE'
#	myPlayerList = playerlib.getPlayerList('#all')
#	for ply in myPlayerList:
#		es.stopsound(int(ply.userid),getsound('HEGRENADE_BOUNCE_DEF'))

#def player_radio(ev):
	#print str(ev['slot'])
	#es.msg(ev['slot'])

#def player_chat(ev):
	#es.msg('!!1')
	#es.msg(ev['text'])

#def player_say(ev):
	#es.msg('2!!1')
	#es.msg(ev['text'])


#def weapon_fire(ev):
#	global nm_userid
#	if ev["weapon"] == "hegrenade":
		#es.emitsound('player',int(ev['userid']), "player\sprayer.wav",1.0,0.5)
		#map(lambda temp: es.cexec(temp, "play %s" % 'radio/ct_fireinhole.wav'), es.getUseridList())
		#nm_userid = ev["userid"]
		#gamethread.delayed(0.2, setprop)
		#return 0


def setprop():
	global nm_userid
	nm_player = es.getplayerhandle(nm_userid)
	nm_entlist = es.createentitylist("hegrenade_projectile")
	nm_string = 0
	nm_entity = 0
	nm_temp = 0
	nm_damage = 100
	nm_radius = 350
	for nm_temp in nm_entlist:
		nm_string = es.getindexprop(nm_temp, "CBaseGrenade.m_hThrower")
		if nm_string == nm_player:
			nm_entity = nm_temp
	if nm_entity:
		es.setindexprop(nm_entity, "CBaseGrenade.m_flDamage", nm_damage)
		es.setindexprop(nm_entity, "CBaseGrenade.m_DmgRadius", nm_radius)
	#for userid in useridlist:
	#	playerHandle = es.getplayerhandle(userid)
	#	if "hegrenade_projectile" in useridlist[userid]:
	#		for index in helist:
	#			owner = es.getindexprop(index,"CBaseEntity.m_hOwnerEntity")
	#			if playerHandle == owner:
	#				setEntityModel(index, useridlist[userid]["hegrenade_projectile"]["world"])


def stpsnd(uid):
	#es.cexec_all('ignorerad')
	es.stopsound(uid,'radio/ct_fireinhole.wav')

def server_message(ev):
	es.msg('srv mess')

# spec functions
def get_snd(sndname):
	if len(sounds[sndname]['SOUNDS'])==0:
		return ''
	elif sounds[sndname]['ENABLE']==0:
		return ''
	else:
		return sounds[sndname]['SOUNDS'][random.randint(0,len(sounds[sndname]['SOUNDS']) - 1)]

def play_snd(userid,sndname,vol):
	if sndname<>'':
		es.playsound(userid,sndname,vol)

def getlead():
	global ct_lead, t_lead
	# CT Lead
	new_lead = 0
	l_deaths = 0
	l_kills = 0
	myPlayerList = playerlib.getPlayerList('#ct')
	for ply in myPlayerList:
		if ply.get('kills') == l_kills:
			if ply.get('deaths') < l_deaths:
				new_lead = int(ply.userid)
				l_kills = ply.get('kills')
				l_deaths = ply.get('deaths')
		if ply.get('kills') > l_kills:
			new_lead = int(ply.userid)
			l_kills = ply.get('kills')
			l_deaths = ply.get('deaths')
	if new_lead<>ct_lead:
		if ct_lead<>0:
			play_snd(ct_lead,get_snd('LOSTLEAD'),'1.0')
			#es.playsound(ct_lead,getsound('LOSTLEAD'),'1.0')
		if new_lead<>0:
			play_snd(new_lead,get_snd('TAKENLEAD'),'1.0')
			#es.playsound(new_lead,getsound('TAKENLEAD'),'1.0')
		ct_lead = new_lead
	#Ter Lead
	new_lead = 0
	l_deaths = 0
	l_kills = 0
	myPlayerList = playerlib.getPlayerList('#t')
	for ply in myPlayerList:
		if ply.get('kills') == l_kills:
			if ply.get('deaths') < l_deaths:
				new_lead = int(ply.userid)
				l_kills = ply.get('kills')
				l_deaths = ply.get('deaths')
		if ply.get('kills') > l_kills:
			new_lead = int(ply.userid)
			l_kills = ply.get('kills')
			l_deaths = ply.get('deaths')
	if new_lead<>t_lead:
		if t_lead<>0:
			play_snd(t_lead,get_snd('LOSTLEAD'),'1.0')
			#es.playsound(t_lead,getsound('LOSTLEAD'),'1.0')
		if new_lead<>0:
			play_snd(new_lead,get_snd('TAKENLEAD'),'1.0')
			#es.playsound(new_lead,getsound('TAKENLEAD'),'1.0')
		t_lead = new_lead

def downstr():
	for soundlist in sounds:
		if sounds[soundlist]['ENABLE']==1:
			for sound in sounds[soundlist]['SOUNDS']:
				es.stringtable('downloadables', 'sound/%s' % sound)
	es.stringtable('downloadables', 'sound/%s' % 'radio/ct_fireinhole.wav')

def loadsets():
	global plrset
	if os.path.isfile(es.getAddonPath('rsounds') + '/nomusiclist.txt'):
		a = open(es.getAddonPath('rsounds') + '/nomusiclist.txt' , 'r')
		b = a.readlines()
		a.close
		for a in b:
			plrset.append(a.strip())

def savesets():
	global plrset
	a = open(es.getAddonPath('rsounds') + '/nomusiclist.txt' , 'w')
	for b in plrset:
		a.writelines(b + chr(10))
	a.close
